// kids_uno.js
(function(ext) {
    var device = null;
    var _rxBuf = [];

    var colourpins = {
      red_1:17,
      green_1:15,
      blue_1:16,
      red_2:9,
      green_2:11,
      blue_2:10,

    };

    var levels = {
      ON:1,
      OFF:0
    };
    var tones ={"B0":31,"C1":33,"D1":37,"E1":41,"F1":44,"G1":49,"A1":55,"B1":62,
  			"C2":65,"D2":73,"E2":82,"F2":87,"G2":98,"A2":110,"B2":123,
  			"C3":131,"D3":147,"E3":165,"F3":175,"G3":196,"A3":220,"B3":247,
  			"C4":262,"D4":294,"E4":330,"F4":349,"G4":392,"A4":440,"B4":494,
  			"C5":523,"D5":587,"E5":659,"F5":698,"G5":784,"A5":880,"B5":988,
  			"C6":1047,"D6":1175,"E6":1319,"F6":1397,"G6":1568,"A6":1760,"B6":1976,
  			"C7":2093,"D7":2349,"E7":2637,"F7":2794,"G7":3136,"A7":3520,"B7":3951,
  	"C8":4186,"D8":4699};
  	var beats = {"Half":500,"Quarter":250,"Eighth":125,"Whole":1000,"Double":2000,"Zero":0};

    ext.runArduino = function(){
  		responseValue();
  	};

    ext.runDigital = function(colourpin,level) {
          runPackage(30,typeof colourpin=="string"?colourpins[colourpin]:new Number(colourpin),typeof level=="string"?levels[level]:new Number(level));
      };

      ext.runTone = function(tone,beat){
    		runPackage(34,short2array(typeof tone=="number"?tone:tones[tone]),short2array(typeof beat=="number"?beat:beats[beat]));
    	};
      ext.forward = function() {

    };
    ext.backward = function() {

    };
    ext.left = function() {

    };
    ext.right = function() {

    };
    ext.stop = function() {

    };
    ext.readBluetooth = function() {



    };
    ext.useBluetooth = function() {
    };

    ext.useBluetooth1 = function() {
    };
    ext.useBluetooth11 = function() {
    };







    function processData(bytes) {
        trace(bytes);
    }

    function appendBuffer( buffer1, buffer2 ) {
        return buffer1.concat( buffer2 );
    }
    // Extension API interactions
    var potentialDevices = [];
    ext._deviceConnected = function(dev) {
        potentialDevices.push(dev);

        if (!device) {
            tryNextDevice();
        }
    }

    function tryNextDevice() {
        // If potentialDevices is empty, device will be undefined.
        // That will get us back here next time a device is connected.
        device = potentialDevices.shift();
        if (device) {
            device.open({ stopBits: 0, bitRate: 115200, ctsFlowControl: 0 }, deviceOpened);
        }
    }

    function deviceOpened(dev) {
        if (!dev) {
            // Opening the port failed.
            tryNextDevice();
            return;
        }
        device.set_receive_handler('kids_uno1',function(data) {
            processData(data);
        });
    };

    ext._deviceRemoved = function(dev) {
        if(device != dev) return;
        device = null;
    };

    ext._shutdown = function() {
        if(device) device.close();
        device = null;
    };

    ext._getStatus = function() {
        if(!device) return {status: 1, msg: 'kids_uno1 disconnected'};
        if(watchdog) return {status: 1, msg: 'Probing for kids_uno1'};
        return {status: 2, msg: 'kids_uno1 connected'};
    }

    ext.getAnalog = function(nextID,pin) {
  		var deviceId = 31;
  		getPackage(nextID,deviceId,pin);
      };

    var descriptor = {};
	ScratchExtensions.register('kids_uno1', descriptor, ext, {type: 'serial'});
})({});
