#ifndef IRREMOTEEXT_H
#define IRREMOTEEXT_H

typedef void (*__ir_handler_type)(unsigned long);

extern void beginIRremote(int pin);

extern void addPressHandlerIRremote(unsigned long code, __ir_handler_type func);
extern void addReleaseHandlerIRremote(unsigned long code, __ir_handler_type func);

extern void handelIRremote();
extern unsigned long getPressedIRremote();
extern bool isReleasedIRremote(unsigned long code);


#define IR_CODE_FWD	0x80562758
#define IR_CODE_BKD	0x8056A759
#define IR_CODE_LEFT 0x8056A75A
#define IR_CODE_RIGHT 0x8056275B
#define IR_CODE_OK 0x8056A75C
#define IR_CODE_BACK 0x805627A9
#define IR_CODE_1 0x8056A701
#define IR_CODE_2	0x80562702
#define IR_CODE_3	0x8056A703
#define IR_CODE_4	0x80562704
#define IR_CODE_5	0x8056A705
#define IR_CODE_6	0x8056A706
#define IR_CODE_7	0x80562707
#define IR_CODE_8	0x8056A708
#define IR_CODE_9	0x8056A709


#endif
